Index: /haskell/trunk/ADLParser.hs
===================================================================
--- /haskell/trunk/ADLParser.hs	(revision 30)
+++ /haskell/trunk/ADLParser.hs	(revision 20)
@@ -24,5 +24,6 @@
                  return ontology
 
-adlVersion :: Parser Version
+
+adlVersion :: Parser String
 adlVersion = do dec1 <- string "archetype (adl_version="
                 ver <- many anyChar
@@ -51,34 +52,3 @@
 
 adlLanguage :: Parser Language
-adlLanguage = do spaces
-                 head <- string "language"
-                 
 
-
-parseAtoms :: Parser [Atom]
-parseAtoms = many atom
-    where
-      atom :: Parser Atom
-      atom = do spaces
-                name <- string
-                spaces
-                equal <- char '='
-                spaces
-      <|> return []
-
-
-data Language = Original_Laguage String
-              | Translaions [Transpation]
-                deriving Show
-
-data Translation = Symbol String
-                 | Language String
-                 | Author Author
-
-data Author = Name String
-            | Organisation String
-
-data Atom = Name String
-          | Description String
-
-type Version :: String
Index: /ruby/trunk/adl_parser/Rakefile
===================================================================
--- /ruby/trunk/adl_parser/Rakefile	(revision 30)
+++ /ruby/trunk/adl_parser/Rakefile	(revision 20)
@@ -83,14 +83,13 @@
   s.email = 'akimichi_tatsukawa@nifty.com'
   s.test_files = FileList['tests/*_test.rb', '*.adl']
-  candidates = Dir.glob("{bin,docs,lib,tests,ext}/**/*")
+  candidates = Dir.glob("{bin, docs, lib, tests, ext}/**/*")
   s.files = candidates.delete_if do |item|
     item.include?(".svn") || item.include?("rdoc")
   end
-  s.files = FileList['README', 'COPYING', 'Rakefile']
+  FileList['README', 'COPYING', 'Rakefile']
   s.require_path = "lib"
   s.has_rdoc = true
   s.extra_rdoc_files = ["README"]
   s.add_dependency("yaparc", ">= 0.2.0")
-  s.add_dependency("openehr_models", ">= 0.0.1")
 end
 
Index: /ruby/trunk/adl_parser/lib/parser.rb
===================================================================
--- /ruby/trunk/adl_parser/lib/parser.rb	(revision 30)
+++ /ruby/trunk/adl_parser/lib/parser.rb	(revision 20)
@@ -13,6 +13,5 @@
 require 'lib/util.rb'
 require 'lib/scanner.rb'
-require 'rubygems'
-require 'am.rb'
+require 'lib/model.rb'
 $DEBUG = true
 
@@ -26,11 +25,5 @@
     class Parser < Racc::Parser
 
-module_eval <<'..end lib/parser.y modeval..id3b9eed63e6', 'lib/parser.y', 1127
-
-def assert_at(file,line, message = "")
-  unless yield
-    raise "Assertion failed !: #{file}, #{line}: #{message}"
-  end
-end
+module_eval <<'..end lib/parser.y modeval..id134a7f5a66', 'lib/parser.y', 739
 
 @@log = Logger.new('log/parser.log','daily')
@@ -819,5 +812,5 @@
 
 
-..end lib/parser.y modeval..id3b9eed63e6
+..end lib/parser.y modeval..id134a7f5a66
 
 ##### racc 1.4.5 generates ###
@@ -825,49 +818,49 @@
 racc_reduce_table = [
  0, 0, :racc_error,
- 2, 95, :_reduce_1,
+ 2, 95, :_reduce_none,
  1, 95, :_reduce_none,
- 8, 96, :_reduce_3,
- 2, 97, :_reduce_4,
- 2, 97, :_reduce_5,
- 1, 105, :_reduce_6,
- 2, 105, :_reduce_7,
- 3, 106, :_reduce_8,
- 1, 107, :_reduce_9,
- 3, 107, :_reduce_10,
- 3, 108, :_reduce_11,
- 1, 108, :_reduce_12,
+ 8, 96, :_reduce_none,
+ 2, 97, :_reduce_none,
+ 2, 97, :_reduce_none,
+ 1, 105, :_reduce_none,
+ 2, 105, :_reduce_none,
+ 3, 106, :_reduce_none,
+ 1, 107, :_reduce_none,
+ 3, 107, :_reduce_none,
+ 3, 108, :_reduce_none,
+ 1, 108, :_reduce_none,
  0, 98, :_reduce_none,
  2, 98, :_reduce_none,
  2, 98, :_reduce_none,
- 2, 99, :_reduce_16,
  2, 99, :_reduce_none,
- 0, 100, :_reduce_18,
+ 2, 99, :_reduce_none,
+ 0, 100, :_reduce_none,
  2, 100, :_reduce_19,
  2, 100, :_reduce_none,
  0, 101, :_reduce_none,
- 2, 101, :_reduce_22,
  2, 101, :_reduce_none,
- 2, 102, :_reduce_24,
+ 2, 101, :_reduce_none,
  2, 102, :_reduce_none,
- 1, 110, :_reduce_26,
- 1, 110, :_reduce_27,
- 5, 111, :_reduce_28,
- 5, 111, :_reduce_29,
- 2, 113, :_reduce_30,
+ 2, 102, :_reduce_none,
+ 1, 110, :_reduce_none,
+ 1, 110, :_reduce_none,
+ 5, 111, :_reduce_none,
+ 5, 111, :_reduce_none,
+ 2, 113, :_reduce_none,
  1, 115, :_reduce_31,
  2, 115, :_reduce_32,
  1, 114, :_reduce_none,
- 1, 114, :_reduce_34,
- 1, 120, :_reduce_35,
- 1, 120, :_reduce_36,
- 1, 120, :_reduce_37,
- 1, 120, :_reduce_38,
- 1, 120, :_reduce_39,
- 1, 120, :_reduce_40,
- 1, 120, :_reduce_41,
- 1, 120, :_reduce_42,
+ 1, 114, :_reduce_none,
  1, 120, :_reduce_none,
  1, 120, :_reduce_none,
- 3, 121, :_reduce_45,
+ 1, 120, :_reduce_none,
+ 1, 120, :_reduce_none,
+ 1, 120, :_reduce_none,
+ 1, 120, :_reduce_none,
+ 1, 120, :_reduce_none,
+ 1, 120, :_reduce_none,
+ 1, 120, :_reduce_none,
+ 1, 120, :_reduce_none,
+ 3, 121, :_reduce_none,
  4, 122, :_reduce_none,
  3, 122, :_reduce_none,
@@ -877,24 +870,24 @@
  3, 132, :_reduce_none,
  2, 132, :_reduce_none,
- 1, 127, :_reduce_53,
- 1, 133, :_reduce_54,
- 1, 133, :_reduce_55,
- 1, 133, :_reduce_56,
- 1, 133, :_reduce_57,
- 1, 133, :_reduce_58,
- 1, 133, :_reduce_59,
- 1, 133, :_reduce_60,
- 1, 133, :_reduce_61,
+ 1, 127, :_reduce_none,
+ 1, 133, :_reduce_none,
+ 1, 133, :_reduce_none,
+ 1, 133, :_reduce_none,
+ 1, 133, :_reduce_none,
+ 1, 133, :_reduce_none,
+ 1, 133, :_reduce_none,
+ 1, 133, :_reduce_none,
+ 1, 133, :_reduce_none,
  1, 118, :_reduce_none,
- 1, 119, :_reduce_63,
- 2, 119, :_reduce_64,
- 5, 142, :_reduce_65,
- 5, 142, :_reduce_66,
- 5, 142, :_reduce_67,
+ 1, 119, :_reduce_none,
+ 2, 119, :_reduce_none,
+ 5, 142, :_reduce_none,
+ 5, 142, :_reduce_none,
+ 5, 142, :_reduce_none,
  2, 143, :_reduce_68,
  3, 143, :_reduce_69,
- 1, 144, :_reduce_70,
- 2, 144, :_reduce_71,
- 1, 144, :_reduce_72,
+ 1, 144, :_reduce_none,
+ 2, 144, :_reduce_none,
+ 1, 144, :_reduce_none,
  0, 130, :_reduce_none,
  2, 130, :_reduce_none,
@@ -909,40 +902,40 @@
  2, 103, :_reduce_none,
  2, 103, :_reduce_none,
- 2, 104, :_reduce_85,
+ 2, 104, :_reduce_none,
  2, 104, :_reduce_none,
  1, 109, :_reduce_none,
  1, 151, :_reduce_none,
  1, 151, :_reduce_none,
- 1, 152, :_reduce_90,
- 2, 152, :_reduce_91,
- 3, 152, :_reduce_92,
+ 1, 152, :_reduce_none,
+ 2, 152, :_reduce_none,
+ 3, 152, :_reduce_none,
  3, 154, :_reduce_93,
  1, 155, :_reduce_94,
  2, 155, :_reduce_none,
- 1, 156, :_reduce_96,
- 1, 156, :_reduce_97,
- 1, 153, :_reduce_98,
- 1, 153, :_reduce_99,
- 1, 159, :_reduce_100,
- 2, 159, :_reduce_101,
- 3, 160, :_reduce_102,
+ 1, 156, :_reduce_none,
+ 1, 156, :_reduce_none,
+ 1, 153, :_reduce_none,
+ 1, 153, :_reduce_none,
+ 1, 159, :_reduce_none,
+ 2, 159, :_reduce_none,
+ 3, 160, :_reduce_none,
  1, 161, :_reduce_103,
- 1, 162, :_reduce_104,
- 2, 162, :_reduce_105,
+ 1, 162, :_reduce_none,
+ 2, 162, :_reduce_none,
  3, 163, :_reduce_106,
  3, 164, :_reduce_107,
- 1, 158, :_reduce_108,
- 2, 158, :_reduce_109,
- 2, 166, :_reduce_110,
- 3, 166, :_reduce_111,
+ 1, 158, :_reduce_none,
+ 2, 158, :_reduce_none,
+ 2, 166, :_reduce_none,
+ 3, 166, :_reduce_none,
  1, 167, :_reduce_none,
- 1, 157, :_reduce_113,
- 2, 157, :_reduce_114,
+ 1, 157, :_reduce_none,
+ 2, 157, :_reduce_none,
  3, 168, :_reduce_115,
- 1, 169, :_reduce_116,
- 1, 169, :_reduce_117,
- 1, 169, :_reduce_118,
- 1, 169, :_reduce_119,
- 1, 169, :_reduce_120,
+ 1, 169, :_reduce_none,
+ 1, 169, :_reduce_none,
+ 1, 169, :_reduce_none,
+ 1, 169, :_reduce_none,
+ 1, 169, :_reduce_none,
  1, 165, :_reduce_121,
  1, 165, :_reduce_122,
@@ -976,7 +969,7 @@
  3, 184, :_reduce_none,
  3, 184, :_reduce_none,
- 1, 175, :_reduce_152,
- 2, 175, :_reduce_153,
- 2, 175, :_reduce_154,
+ 1, 175, :_reduce_none,
+ 2, 175, :_reduce_none,
+ 2, 175, :_reduce_none,
  3, 185, :_reduce_none,
  3, 185, :_reduce_none,
@@ -991,7 +984,7 @@
  4, 193, :_reduce_none,
  3, 193, :_reduce_none,
- 1, 176, :_reduce_167,
- 2, 176, :_reduce_168,
- 2, 176, :_reduce_169,
+ 1, 176, :_reduce_none,
+ 2, 176, :_reduce_none,
+ 2, 176, :_reduce_none,
  3, 186, :_reduce_none,
  3, 186, :_reduce_none,
@@ -1006,6 +999,6 @@
  4, 194, :_reduce_none,
  3, 194, :_reduce_none,
- 1, 177, :_reduce_182,
- 1, 177, :_reduce_183,
+ 1, 177, :_reduce_none,
+ 1, 177, :_reduce_none,
  3, 187, :_reduce_none,
  3, 187, :_reduce_none,
@@ -1114,9 +1107,9 @@
  2, 206, :_reduce_288,
  1, 206, :_reduce_289,
- 0, 145, :_reduce_290,
- 5, 145, :_reduce_291,
- 1, 207, :_reduce_292,
- 3, 207, :_reduce_293,
- 5, 146, :_reduce_294,
+ 0, 145, :_reduce_none,
+ 5, 145, :_reduce_none,
+ 1, 207, :_reduce_none,
+ 3, 207, :_reduce_none,
+ 5, 146, :_reduce_none,
  1, 208, :_reduce_none,
  3, 208, :_reduce_none,
@@ -1130,5 +1123,5 @@
  1, 210, :_reduce_none,
  0, 116, :_reduce_none,
- 5, 116, :_reduce_306,
+ 5, 116, :_reduce_none,
  2, 116, :_reduce_none,
  1, 209, :_reduce_none,
@@ -1177,11 +1170,11 @@
  3, 140, :_reduce_none,
  3, 140, :_reduce_none,
- 1, 219, :_reduce_353,
- 1, 219, :_reduce_354,
- 3, 219, :_reduce_355,
- 3, 219, :_reduce_356,
- 1, 141, :_reduce_357,
- 3, 141, :_reduce_358,
- 3, 141, :_reduce_359,
+ 1, 219, :_reduce_none,
+ 1, 219, :_reduce_none,
+ 3, 219, :_reduce_none,
+ 3, 219, :_reduce_none,
+ 1, 141, :_reduce_none,
+ 3, 141, :_reduce_none,
+ 3, 141, :_reduce_none,
  1, 126, :_reduce_none,
  3, 126, :_reduce_none,
@@ -1199,5 +1192,5 @@
  1, 149, :_reduce_none,
  1, 149, :_reduce_374,
- 1, 217, :_reduce_375 ]
+ 1, 217, :_reduce_none ]
 
 racc_reduce_n = 376
@@ -2019,101 +2012,27 @@
  # reduce 0 omitted
 
-module_eval <<'.,.,', 'lib/parser.y', 32
-  def _reduce_1( val, _values, result )
-    result = val[0]
-   result
-  end
-.,.,
+ # reduce 1 omitted
 
  # reduce 2 omitted
 
-module_eval <<'.,.,', 'lib/parser.y', 57
-  def _reduce_3( val, _values, result )
-    assert_at(__FILE__,__LINE__) do
-      val[4].instance_of?(OpenEHR::AM::Archetype::Archetype_Description::ARCHETYPE_DESCRIPTION) and val[5].instance_of?(OpenEHR::AM::Archetype::Constraint_Model::C_COMPLEX_OBJECT) and val[7].instance_of?(OpenEHR::AM::Archetype::Ontology::ARCHETYPE_ONTOLOGY) 
-    end
-    
-    archetype_id = val[0][:archetype_id]
-    adl_version = val[0][:arch_head][:arch_meta_data][:adl_version]
-    concept = val[2]
-    language = val[3][:arch_language]
-    archetype = OpenEHR::AM::Archetype::ARCHETYPE.create(
-                                                         :archetype_id => archetype_id,
-                                                         :adl_version => adl_version,
-                                                         :concept => concept,
-                                                         :description => val[4],
-                                                         :definition => val[5],
-                                                         :ontology => val[7]
-                                                         ) do |archetype|
-      archetype.original_language = language
-    end
-    @@log.info("#{__FILE__}:#{__LINE__}: archetype = #{archetype} at #{@filename}:#{@lineno}")
-    result = archetype
-   result
-  end
-.,.,
-
-module_eval <<'.,.,', 'lib/parser.y', 63
-  def _reduce_4( val, _values, result )
-    result = {:arch_head => val[0], :archetype_id => val[1] }
-   result
-  end
-.,.,
-
-module_eval <<'.,.,', 'lib/parser.y', 67
-  def _reduce_5( val, _values, result )
-    raise
-   result
-  end
-.,.,
-
-module_eval <<'.,.,', 'lib/parser.y', 72
-  def _reduce_6( val, _values, result )
-    result = {:arch_meta_data => nil }
-   result
-  end
-.,.,
-
-module_eval <<'.,.,', 'lib/parser.y', 76
-  def _reduce_7( val, _values, result )
-    result = val[1]
-   result
-  end
-.,.,
-
-module_eval <<'.,.,', 'lib/parser.y', 81
-  def _reduce_8( val, _values, result )
-    result = {:arch_meta_data => val[1] }
-   result
-  end
-.,.,
-
-module_eval <<'.,.,', 'lib/parser.y', 86
-  def _reduce_9( val, _values, result )
-    result = val[0]
-   result
-  end
-.,.,
-
-module_eval <<'.,.,', 'lib/parser.y', 90
-  def _reduce_10( val, _values, result )
-    result = val[0].merge(val[2])
-   result
-  end
-.,.,
-
-module_eval <<'.,.,', 'lib/parser.y', 96
-  def _reduce_11( val, _values, result )
-    result = {:adl_version => val[2], :is_controlled => false }
-   result
-  end
-.,.,
-
-module_eval <<'.,.,', 'lib/parser.y', 100
-  def _reduce_12( val, _values, result )
-    result = {:is_controlled => true }
-   result
-  end
-.,.,
+ # reduce 3 omitted
+
+ # reduce 4 omitted
+
+ # reduce 5 omitted
+
+ # reduce 6 omitted
+
+ # reduce 7 omitted
+
+ # reduce 8 omitted
+
+ # reduce 9 omitted
+
+ # reduce 10 omitted
+
+ # reduce 11 omitted
+
+ # reduce 12 omitted
 
  # reduce 13 omitted
@@ -2123,104 +2042,49 @@
  # reduce 15 omitted
 
+ # reduce 16 omitted
+
+ # reduce 17 omitted
+
+ # reduce 18 omitted
+
+module_eval <<'.,.,', 'lib/parser.y', 74
+  def _reduce_19( val, _values, result )
+    result = {:language => val[1]}
+   result
+  end
+.,.,
+
+ # reduce 20 omitted
+
+ # reduce 21 omitted
+
+ # reduce 22 omitted
+
+ # reduce 23 omitted
+
+ # reduce 24 omitted
+
+ # reduce 25 omitted
+
+ # reduce 26 omitted
+
+ # reduce 27 omitted
+
+ # reduce 28 omitted
+
+ # reduce 29 omitted
+
+ # reduce 30 omitted
+
 module_eval <<'.,.,', 'lib/parser.y', 111
-  def _reduce_16( val, _values, result )
-    result = {:arch_concept => val[1] }
-   result
-  end
-.,.,
-
- # reduce 17 omitted
-
-module_eval <<'.,.,', 'lib/parser.y', 121
-  def _reduce_18( val, _values, result )
-    result = {:arch_language => nil}
-   result
-  end
-.,.,
-
-module_eval <<'.,.,', 'lib/parser.y', 125
-  def _reduce_19( val, _values, result )
-    result = {:arch_language => val[1]}
-   result
-  end
-.,.,
-
- # reduce 20 omitted
-
- # reduce 21 omitted
-
-module_eval <<'.,.,', 'lib/parser.y', 136
-  def _reduce_22( val, _values, result )
-    result = OpenEHR::AM::Archetype::Archetype_Description::ARCHETYPE_DESCRIPTION.new(:details => val[1])
-   result
-  end
-.,.,
-
- # reduce 23 omitted
-
-module_eval <<'.,.,', 'lib/parser.y', 144
-  def _reduce_24( val, _values, result )
-    result = val[1]
-   result
-  end
-.,.,
-
- # reduce 25 omitted
-
-module_eval <<'.,.,', 'lib/parser.y', 154
-  def _reduce_26( val, _values, result )
-    assert_at(__FILE__,__LINE__){val[0].instance_of?(OpenEHR::AM::Archetype::Constraint_Model::C_COMPLEX_OBJECT)}
-    @@log.info("#{__FILE__}:#{__LINE__}: c_complex_object = #{val[0]} at #{@filename}:#{@lineno}")
-    result = val[0]
-   result
-  end
-.,.,
-
-module_eval <<'.,.,', 'lib/parser.y', 158
-  def _reduce_27( val, _values, result )
-    result = val[0]
-   result
-  end
-.,.,
-
-module_eval <<'.,.,', 'lib/parser.y', 169
-  def _reduce_28( val, _values, result )
-    result = OpenEHR::AM::Archetype::Constraint_Model::C_COMPLEX_OBJECT.create(:attributes => val[3]) do |c_complex_object|
-      c_complex_object.node_id = val[0][:c_complex_object_id][:local_term_code_ref]
-      c_complex_object.rm_type_name = val[0][:c_complex_object_id][:type_identifier]
-      c_complex_object.occurrences = val[0][:c_occurrences]
-    end
-   result
-  end
-.,.,
-
-module_eval <<'.,.,', 'lib/parser.y', 177
-  def _reduce_29( val, _values, result )
-    result = OpenEHR::AM::Archetype::Constraint_Model::C_COMPLEX_OBJECT.create(:attributes => val[3]) do |c_complex_object|
-      c_complex_object.node_id = val[0][:c_complex_object_id][:local_term_code_ref]
-      c_complex_object.rm_type_name = val[0][:c_complex_object_id][:type_identifier]
-      c_complex_object.occurrences = val[0][:c_occurrences]
-    end
-   result
-  end
-.,.,
-
-module_eval <<'.,.,', 'lib/parser.y', 184
-  def _reduce_30( val, _values, result )
-    result = {:c_complex_object_id => val[0], :c_occurrences => val[1]}
-   result
-  end
-.,.,
-
-module_eval <<'.,.,', 'lib/parser.y', 189
   def _reduce_31( val, _values, result )
-    result = {:type_identifier => val[0]}
-   result
-  end
-.,.,
-
-module_eval <<'.,.,', 'lib/parser.y', 193
+    result = {:c_complex_object_id => {:type_identifier => val[0]}}
+   result
+  end
+.,.,
+
+module_eval <<'.,.,', 'lib/parser.y', 115
   def _reduce_32( val, _values, result )
-    result = {:type_identifier => val[0], :local_term_code_ref => val[1]}
+    result = {:c_complex_object_id => {:type_identifier => val[0], :V_LOCAL_TERM_CODE_REF => val[1]}}
    result
   end
@@ -2229,66 +2093,21 @@
  # reduce 33 omitted
 
-module_eval <<'.,.,', 'lib/parser.y', 199
-  def _reduce_34( val, _values, result )
-    result = OpenEHR::AM::Archetype::Constraint_Model::C_COMPLEX_OBJECT.new(:attributes => val[0])
-   result
-  end
-.,.,
-
-module_eval <<'.,.,', 'lib/parser.y', 207
-  def _reduce_35( val, _values, result )
-    result = val[0]
-   result
-  end
-.,.,
-
-module_eval <<'.,.,', 'lib/parser.y', 211
-  def _reduce_36( val, _values, result )
-    result = OpenEHR::AM::Archetype::Constraint_Model::C_COMPLEX_OBJECT.new
-   result
-  end
-.,.,
-
-module_eval <<'.,.,', 'lib/parser.y', 215
-  def _reduce_37( val, _values, result )
-    result = OpenEHR::AM::Archetype::Constraint_Model::ARCHETYPE_INTERNAL_REF.new
-   result
-  end
-.,.,
-
-module_eval <<'.,.,', 'lib/parser.y', 219
-  def _reduce_38( val, _values, result )
-    result = OpenEHR::AM::Archetype::Constraint_Model::ARCHETYPE_SLOT.new
-   result
-  end
-.,.,
-
-module_eval <<'.,.,', 'lib/parser.y', 223
-  def _reduce_39( val, _values, result )
-    result = OpenEHR::AM::Archetype::Constraint_Model::CONSTRAINT_REF.new
-   result
-  end
-.,.,
-
-module_eval <<'.,.,', 'lib/parser.y', 227
-  def _reduce_40( val, _values, result )
-    result = val[0]
-   result
-  end
-.,.,
-
-module_eval <<'.,.,', 'lib/parser.y', 231
-  def _reduce_41( val, _values, result )
-    result = val[0]
-   result
-  end
-.,.,
-
-module_eval <<'.,.,', 'lib/parser.y', 235
-  def _reduce_42( val, _values, result )
-    result = val[0]
-   result
-  end
-.,.,
+ # reduce 34 omitted
+
+ # reduce 35 omitted
+
+ # reduce 36 omitted
+
+ # reduce 37 omitted
+
+ # reduce 38 omitted
+
+ # reduce 39 omitted
+
+ # reduce 40 omitted
+
+ # reduce 41 omitted
+
+ # reduce 42 omitted
 
  # reduce 43 omitted
@@ -2296,10 +2115,5 @@
  # reduce 44 omitted
 
-module_eval <<'.,.,', 'lib/parser.y', 250
-  def _reduce_45( val, _values, result )
-    result = val[1]
-   result
-  end
-.,.,
+ # reduce 45 omitted
 
  # reduce 46 omitted
@@ -2317,163 +2131,53 @@
  # reduce 52 omitted
 
-module_eval <<'.,.,', 'lib/parser.y', 270
-  def _reduce_53( val, _values, result )
-    assert_at(__FILE__,__LINE__){val[0].kind_of?(OpenEHR::AM::Archetype::Constraint_Model::Primitive::C_PRIMITIVE)}
-    result = OpenEHR::AM::Archetype::Constraint_Model::C_PRIMITIVE_OBJECT.new(:item => val[0])
-   result
-  end
-.,.,
-
-module_eval <<'.,.,', 'lib/parser.y', 276
-  def _reduce_54( val, _values, result )
-    @@log.info("#{__FILE__}:#{__LINE__}: c_integer = #{val[0]} at #{@filename}:#{@lineno}")
-    result = OpenEHR::AM::Archetype::Constraint_Model::Primitive::C_INTEGER.new
-   result
-  end
-.,.,
-
-module_eval <<'.,.,', 'lib/parser.y', 281
-  def _reduce_55( val, _values, result )
-    @@log.info("#{__FILE__}:#{__LINE__}: c_real = #{val[0]} at #{@filename}:#{@lineno}")
-    result = OpenEHR::AM::Archetype::Constraint_Model::Primitive::C_REAL.new
-   result
-  end
-.,.,
-
-module_eval <<'.,.,', 'lib/parser.y', 286
-  def _reduce_56( val, _values, result )
-    @@log.info("#{__FILE__}:#{__LINE__}: c_date = #{val[0]} at #{@filename}:#{@lineno}")
-    result = OpenEHR::AM::Archetype::Constraint_Model::Primitive::C_DATE.new
-   result
-  end
-.,.,
-
-module_eval <<'.,.,', 'lib/parser.y', 291
-  def _reduce_57( val, _values, result )
-    @@log.info("#{__FILE__}:#{__LINE__}: c_time = #{val[0]} at #{@filename}:#{@lineno}")
-    result = OpenEHR::AM::Archetype::Constraint_Model::Primitive::C_TIME.new
-   result
-  end
-.,.,
-
-module_eval <<'.,.,', 'lib/parser.y', 296
-  def _reduce_58( val, _values, result )
-    @@log.info("#{__FILE__}:#{__LINE__}: c_date_time = #{val[0]} at #{@filename}:#{@lineno}")
-    result = OpenEHR::AM::Archetype::Constraint_Model::Primitive::C_DATE_TIME.new
-   result
-  end
-.,.,
-
-module_eval <<'.,.,', 'lib/parser.y', 301
-  def _reduce_59( val, _values, result )
-    @@log.info("#{__FILE__}:#{__LINE__}: c_duration = #{val[0]} at #{@filename}:#{@lineno}")
-    result = OpenEHR::AM::Archetype::Constraint_Model::Primitive::C_DURATION.new
-   result
-  end
-.,.,
-
-module_eval <<'.,.,', 'lib/parser.y', 306
-  def _reduce_60( val, _values, result )
-    @@log.info("#{__FILE__}:#{__LINE__}: c_string = #{val[0]} at #{@filename}:#{@lineno}")
-    result = OpenEHR::AM::Archetype::Constraint_Model::Primitive::C_STRING.new
-   result
-  end
-.,.,
-
-module_eval <<'.,.,', 'lib/parser.y', 312
-  def _reduce_61( val, _values, result )
-    assert_at(__FILE__,__LINE__){val[0].instance_of?(OpenEHR::AM::Archetype::Constraint_Model::Primitive::C_BOOLEAN)}
-    @@log.info("#{__FILE__}:#{__LINE__}: c_boolean = #{val[0]} at #{@filename}:#{@lineno}")
-    result = val[0]
-   result
-  end
-.,.,
+ # reduce 53 omitted
+
+ # reduce 54 omitted
+
+ # reduce 55 omitted
+
+ # reduce 56 omitted
+
+ # reduce 57 omitted
+
+ # reduce 58 omitted
+
+ # reduce 59 omitted
+
+ # reduce 60 omitted
+
+ # reduce 61 omitted
 
  # reduce 62 omitted
 
-module_eval <<'.,.,', 'lib/parser.y', 322
-  def _reduce_63( val, _values, result )
-    result = [val[0]]
-   result
-  end
-.,.,
-
-module_eval <<'.,.,', 'lib/parser.y', 326
-  def _reduce_64( val, _values, result )
-    result = (val[0] << val[1])
-   result
-  end
-.,.,
-
-module_eval <<'.,.,', 'lib/parser.y', 335
-  def _reduce_65( val, _values, result )
-    assert_at(__FILE__,__LINE__){ val[0].kind_of?(OpenEHR::AM::Archetype::Constraint_Model::C_ATTRIBUTE)}
-    c_attribute = val[0]
-    c_attribute.children = val[3]
-    result = c_attribute
-   result
-  end
-.,.,
-
-module_eval <<'.,.,', 'lib/parser.y', 340
-  def _reduce_66( val, _values, result )
-    assert_at(__FILE__,__LINE__){ val[0].kind_of?(OpenEHR::AM::Archetype::Constraint_Model::C_ATTRIBUTE)}
-    result = val[0]
-   result
-  end
-.,.,
-
-module_eval <<'.,.,', 'lib/parser.y', 345
-  def _reduce_67( val, _values, result )
-    assert_at(__FILE__,__LINE__){ val[0].kind_of?(OpenEHR::AM::Archetype::Constraint_Model::C_ATTRIBUTE)}
-    result = val[0]
-   result
-  end
-.,.,
-
-module_eval <<'.,.,', 'lib/parser.y', 356
+ # reduce 63 omitted
+
+ # reduce 64 omitted
+
+ # reduce 65 omitted
+
+ # reduce 66 omitted
+
+ # reduce 67 omitted
+
+module_eval <<'.,.,', 'lib/parser.y', 186
   def _reduce_68( val, _values, result )
     @@log.info("#{__FILE__}:#{__LINE__}: V_ATTRIBUTE_IDENTIFIER = #{val[0]}, c_existence = #{val[1]} at #{@filename}")
-    result = OpenEHR::AM::Archetype::Constraint_Model::C_SINGLE_ATTRIBUTE.new(
-                                                                              :rm_attribute_name => val[0],
-                                                                              :existence => val[1]
-                                                                              )
-   result
-  end
-.,.,
-
-module_eval <<'.,.,', 'lib/parser.y', 366
+   result
+  end
+.,.,
+
+module_eval <<'.,.,', 'lib/parser.y', 190
   def _reduce_69( val, _values, result )
-    assert_at(__FILE__,__LINE__){ val[2].instance_of?(OpenEHR::AM::Archetype::Constraint_Model::CARDINALITY) }
-    @@log.info("#{__FILE__}:#{__LINE__}: V_ATTRIBUTE_IDENTIFIER: #{val[0]}, c_existence = #{val[1]}, c_cardinality = #{val[2]} at #{@filename}") 
-    result = OpenEHR::AM::Archetype::Constraint_Model::C_MULTIPLE_ATTRIBUTE.new(
-                                                                                :rm_attribute_name => val[0],
-                                                                                :existence => val[1],
-                                                                                :cardinality => val[2]
-                                                                                )
-   result
-  end
-.,.,
-
-module_eval <<'.,.,', 'lib/parser.y', 371
-  def _reduce_70( val, _values, result )
-    result = Array[val[0]]
-   result
-  end
-.,.,
-
-module_eval <<'.,.,', 'lib/parser.y', 375
-  def _reduce_71( val, _values, result )
-    result = (val[0] << val[1])
-   result
-  end
-.,.,
-
-module_eval <<'.,.,', 'lib/parser.y', 379
-  def _reduce_72( val, _values, result )
-    result = Array[val[0]]
-   result
-  end
-.,.,
+    @@log.info("#{__FILE__}:#{__LINE__}: V_ATTRIBUTE_IDENTIFIER: #{val[0]}, c_existence = #{val[1]}, c_cardinality = #{val[2]} at #{@filename}")
+   result
+  end
+.,.,
+
+ # reduce 70 omitted
+
+ # reduce 71 omitted
+
+ # reduce 72 omitted
 
  # reduce 73 omitted
@@ -2501,11 +2205,5 @@
  # reduce 84 omitted
 
-module_eval <<'.,.,', 'lib/parser.y', 410
-  def _reduce_85( val, _values, result )
-    dadl_section = val[1]
-    result = OpenEHR::AM::Archetype::Ontology::ARCHETYPE_ONTOLOGY.new
-   result
-  end
-.,.,
+ # reduce 85 omitted
 
  # reduce 86 omitted
@@ -2517,37 +2215,20 @@
  # reduce 89 omitted
 
-module_eval <<'.,.,', 'lib/parser.y', 424
-  def _reduce_90( val, _values, result )
-    result = Array[val[0]]
-   result
-  end
-.,.,
-
-module_eval <<'.,.,', 'lib/parser.y', 428
-  def _reduce_91( val, _values, result )
-    result = (val[0] << val[1])
-   result
-  end
-.,.,
-
-module_eval <<'.,.,', 'lib/parser.y', 432
-  def _reduce_92( val, _values, result )
-    result = (val[0] << val[2])
-   result
-  end
-.,.,
-
-module_eval <<'.,.,', 'lib/parser.y', 438
+ # reduce 90 omitted
+
+ # reduce 91 omitted
+
+ # reduce 92 omitted
+
+module_eval <<'.,.,', 'lib/parser.y', 240
   def _reduce_93( val, _values, result )
     @@log.info("#{__FILE__}:#{__LINE__}: attr_id = #{val[0]}, object_block = #{val[2]} at #{@filename}:#{@lineno}")
-    result = {:attr_id => val[0], :object_block => val[2]}
-   result
-  end
-.,.,
-
-module_eval <<'.,.,', 'lib/parser.y', 444
+   result
+  end
+.,.,
+
+module_eval <<'.,.,', 'lib/parser.y', 245
   def _reduce_94( val, _values, result )
     @@log.info("#{__FILE__}:#{__LINE__}: V_ATTRIBUTE_IDENTIFIER = #{val[0]} at #{@filename}:#{@lineno}")
-    result = val[0]
    result
   end
